#include <stdio.h>
#include <spu_mfcio.h>
#include "vector.h"


int main(unsigned long long spe_id, unsigned long long arg, unsigned long long env)
{
int i,j;
uint32_t tag;
argumento dato __attribute__((aligned(16)));
int op1[LON_VECTOR] __attribute__((aligned(16)));
int res[LON_VECTOR] __attribute__((aligned(16)));


 /* Trae los parametros de la mem principal (arg) al SPE (dato)*/
 
 if((tag=mfc_tag_reserve())==MFC_TAG_INVALID) // reserva una etiqueta de transaccion
 {
   printf("SPE: ERROR - No se puede reservar un tag de trasaccion.\n");
   return 1;
 }
 mfc_get(&dato,arg,sizeof(argumento),tag,0,0);
 mfc_write_tag_mask(1<<tag);
 mfc_read_tag_status_all();
 
 /* Trae los parametros de la mem principal (dato.op1) al SPE (op1)*/
 
 mfc_get(op1,dato.op1,sizeof(int)*dato.lon,tag,0,0);
 mfc_write_tag_mask(1<<tag);
 mfc_read_tag_status_all();

 /* bucle para hacer tiempo */
 for (j=0;j<200000;j++)
 {
    /* Operaciones a realizar */
    for (i=0;i<dato.lon;i++)
    {
        res[i]=op1[i]-1;
    }
 }

 /* Copiar el resultado local de res en la memoria principal a la direccion dato.res*/
 
 mfc_put(res,dato.res,dato.lon*sizeof(int),tag,0,0);
 mfc_write_tag_mask(1<<tag);
 mfc_read_tag_status_all();
 
 mfc_tag_release(tag); // libera la etiqueta de transaccion

 return 0;
}
